#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t,n,k;

    cin>>t;
    cin>>n>>k;

    int a[300000];

    for(int i=0; i<n; i++)
    {
        cin>>a[i];
    }

    int d=-1;


    sort(a,a+n);

    int mini=0, maxi=0;

    int cur=0;

    if(t==1)
    {





        bool lehet=false;

            do
            {
                d+=1;
                if(a[d]>=cur)
                {
                    cur++;
                }
                else
                {
                    cur--;
                }

                if(cur==k)
                {
                    lehet=true;
                    cout<<"DA\n";
                    for(int i=0; i<n; i++)
                    {
                        cout<<a[i]<<" ";
                    }
                    break;
                }
            }while(next_permutation(a,a+n));

            if(!lehet)
            {
                cout<<"NE\n";
            }




    }
    else
    {




        bool lehet=false;

            do
            {
                d+=1;
                if(a[d]>=cur)
                {
                    cur++;
                }
                else
                {
                    cur--;
                }

                if(cur==k)
                {
                    lehet=true;
                    cout<<"DA\n";

                    break;
                }
            }while(next_permutation(a,a+n));

            if(!lehet)
            {
                cout<<"NE\n";
            }
    }



    return 0;
}